unit uMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Objects, FMX.Edit, uFrames,
  FMX.Layouts, FMX.ListBox;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    recHost: TRectangle;
    Label2: TLabel;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    frmFrames: TfrmFrames;
    procedure Frame1ButtonClicked(sender: TOBject);
    procedure Frame1ButtonClickedAdvanced(sender: TObject; var s: string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Button1Click(Sender: TObject);
var
  frmFrames: TfrmFrames;
  lbItem : TListBoxItem;
begin
  lbItem := TListBoxItem.Create(self);
  frmFrames := TfrmFrames.Create(lbItem);

  lbItem.Height := 110;

  frmFrames.rec1.Parent := lbItem;
  frmFrames.rec1.align := TAlignLayout.alClient;

  ListBox1.AddObject(lbItem);


end;



procedure TForm1.Button2Click(Sender: TObject);
var
  frmFrames: TfrmFrames;
  lbItem : TListBoxItem;
begin
  lbItem := TListBoxItem.Create(self);
  frmFrames := TfrmFrames.Create(lbItem);

  lbItem.Height := 110;

  frmFrames.rec2.Parent := lbItem;
  frmFrames.rec2.align := TAlignLayout.alClient;

  ListBox1.AddObject(lbItem);
end;



procedure TForm1.Button3Click(Sender: TObject);
var
  i : integer;
begin
  for i  := 0 to ListBox1.Items.Count  - 1 do
  begin
    Tlabel(ListBox1.ItemByIndex(i).FindBinding('FrameHeader')).Text := format('Frame %d', [i]);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  frmFrames := TfrmFrames.Create(nil);
  frmFrames.rec1.Parent := self.recHost;
  frmFrames.rec1.Align := TAlignLayout.alClient;
  frmFrames.OnFrame1ButtonClicked := Frame1ButtonClicked;
  frmFrames.OnFrame1ButtonClickedAdvanced := Frame1ButtonClickedAdvanced;

 // TLabel(frmFrames.rec1.FindBinding('FrameHeader')).Text := 'Dette er framen';
end;

procedure TForm1.Frame1ButtonClickedAdvanced (sender : TObject; var s :string);
begin
  label1.Text := s;
  s := 'Thank you';
end;

procedure TForm1.Frame1ButtonClicked(sender : TOBject);
begin
  ShowMessage('Someone clicked the button');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

  frmFrames.Release;
end;

end.
